#include <iostream>
#include <cmath>
#include <algorithm>
using namespace std;

const int maxn = 256;
bool lamp1, lamp2;
int n, m, k, n1, m1, dp[maxn][maxn], ans = 0;

void rekursiq(int i, int j, int t)
{
    if(t == 0)
    {
        ++ ans;
        return;
    }
    int pi = i, pj = j+1;
    if(pj > m1)
    {
        pj = 1;
        ++ pi;
        if(pi > n1) return;
    }
    if(lamp1 && lamp2)
    {
        if(i==n1 && j==m1)
        {
            rekursiq(pi, pj, t-1);
            rekursiq(pi, pj, t);
            return;
        }
        if(i==n1 || j==m1)
        {
            if(t-2 >= 0) rekursiq(pi, pj, t-2);
            rekursiq(pi, pj, t);
            return;
        }
        if(t-4 >= 0) rekursiq(pi, pj, t-4);
        rekursiq(pi, pj, t);
        return;
    }
    if(lamp1)
    {
        if(i == n1)
        {
            if(t-2 >= 0) rekursiq(pi, pj, t-2);
            rekursiq(pi, pj, t);
            return;
        }
        if(t-4 >= 0) rekursiq(pi, pj, t-4);
        rekursiq(pi, pj, t);
        return;
    }
    if(lamp2)
    {
        if(j == m1)
        {
            if(t-2 >= 0) rekursiq(pi, pj, t-2);
            rekursiq(pi, pj, t);
            return;
        }
        if(t-4 >= 0) rekursiq(pi, pj, t-4);
        rekursiq(pi, pj, t);
        return;
    }
    if(t-4 >= 0) rekursiq(pi, pj, t-4);
    rekursiq(pi, pj, t);
}

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n >> m >> k ;
    n1 = n/2;
    if(n%2 == 1)
    {
        n1++;
        lamp1 = true;
    }
    m1 = m/2;
    if(m%2 == 1)
    {
        m1++;
        lamp2 = true;
    }
    if(n*m<25)
    {
        rekursiq(1, 1, k);
        cout << ans << '\n' ;
        exit(0);
    }
}

void solve()
{
    int i, j, ind, l;
    for(i=1; i<=n1; ++i)
    {
        for(j=1; j<=m1; ++j)
        {
            ind = (i-1)*m1+j;
            dp[ind][1] = 1;
        }
    }
    //cout << n1 << "  "  << m1 << endl;
    for(i=1; i<=n1; ++i)
    {
        for(j=1; j<=m1; ++j)
        {
            ind = (i-1)*m1+j;
            for(l=2; l<=k; ++l)
                {
                    dp[ind][l] = dp[ind-1][l];
                    if(lamp1 && lamp2 && i==n1 && j==m1)
                    {
                        if(l-1 > 0) dp[ind][l] += dp[ind-1][l-1];
                    }
                    else if(lamp1 && i==n1)
                    {
                        if(l-2 > 0) dp[ind][l] += dp[ind-1][l-2];
                    }
                    else if(lamp2 && j==m1)
                    {
                        if(l-2 > 0) dp[ind][l] += dp[ind-1][l-2];
                    }
                    else
                    {
                        if(l-4 > 0) dp[ind][l] += dp[ind-1][l-4];
                    }
                    //cout << dp[ind][l] << " " ;
                }
                //cout << endl;

        }
    }
    cout << dp[n1*m1][k] << '\n' ;
}

int main()
{
    read();
    solve();
    return 0;
}
