#include<iostream>
#include<cmath>
using namespace std;

const long long maxn = 128;
long long t, n, m, a[maxn], b[maxn], c[maxn], d[maxn], o;

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> t ;
    cin >> n ;
    long long i;
    for(i=1; i<=n; ++i)
    {
        cin >> a[i] >> b[i] ;
    }
    cin >> m ;
    for(i=1; i<=m; ++i)
    {
        cin >> c[i] >> d[i] ;
    }
}

long long check(long long m1)
{
    long long i, cnt1 = 0, cnt2 = 0, m2 = t-m1;
    for(i=1; i<=n; ++i)
    {
        cnt1 += ((m1-a[i])/b[i]);
    }
    for(i=1; i<=m; ++i)
    {
        cnt2 += ((m2-c[i])/d[i]);
    }
    if(cnt1 < cnt2)
    {
        o = m1;
        return -1;
    }
    return (cnt1 == cnt2);
}

long long bin_search()
{
    long long l = 0, r = t;
    long long mid = (l+r)/2;
    long long k = check(mid);
    while(l<=r && k != 1)
    {
        (k == -1) ? l = mid+1 : r = mid-1;
        mid = (l+r)/2;
        k = check(mid);
    }
    if(l > r) return o;
    return mid;
}

void solve()
{
    long long ans = bin_search();
    cout << ans << '\n' ;
}

int main()
{
    read();
    solve();
    return 0;
}
