#include <iostream>
#include <set>
#pragma GCC optimize("O3")
#pragma GCC target("sse4")
using namespace std;
const int maxn = 20000010,  buff_size = 2e5;
int k;
multiset < char > ms;
int curr, ans;
char last, curr_c;

int buff_ix = buff_size-1;
char buff[buff_size];

void read_char() {
    if (++buff_ix == buff_size) fread(buff, buff_size, 1, stdin), buff_ix = 0;
}

void read_int(int &ret) {
    ret = 0;
    for (; buff[buff_ix] < '0' || buff[buff_ix] > '9'; read_char());
    for (; buff[buff_ix] >= '0' && buff[buff_ix] <= '9'; read_char())
        ret = 10*ret + buff[buff_ix] - '0';
}

int len;

void read_string(char s[]) {
    len = 0;
    for (; buff[buff_ix] < 33 || buff[buff_ix] > 126 ; read_char());
    for (; buff[buff_ix] >= 33 && buff[buff_ix] <= 126 ; read_char())
        s[len++] = buff[buff_ix];
    s[len] = '\0';
}

char s[maxn];

int main () {
    fill(buff, buff+buff_size, 0);
    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read_int(k);
    read_string(s);
    for (int i = 0 ; i <= len ; ++i) {
        if (i < len) ms.insert(s[i]);
        if (i >= k) {
            curr_c = (*ms.begin());
            if (curr_c == last) ++curr;
            else {
                ans = max(ans, curr);
                curr = 1;
                last = curr_c;
            }
            ms.erase(ms.find(s[i-k]));
        }
    }
    ans = max(ans, curr);
    cout << ans << '\n';
    return 0;
}
