#include <iostream>
using namespace std;
typedef long long ll;
const ll maxt = 1e9+10, maxn = 110;
struct str {
    ll ready, prod;
    str(){}
    str(ll _ready, ll _prod) {
        ready = _ready;
        prod = _prod;
    }
} a[maxn], b[maxn];
ll t, n, m;

ll check1(ll time) {
    ll res = 0, curr;
    for (ll i = 1 ; i <= n ; ++i) {
        if (a[i].ready > time) continue;
        res += (time-a[i].ready) / a[i].prod + 1;
    }
    return res;
}

ll check2(ll time) {
    ll res = 0, curr;
    for (ll i = 1 ; i <= m ; ++i) {
        if (b[i].ready > time) continue;
        res += (time-b[i].ready) / b[i].prod + 1;
    }
    return res;
}

bool binary2(ll cars) {
    ll l = 0, r = t, m;
    while (l < r - 1) {
        m = (l+r)/2;
        if (check1(m) < cars) l = m;
        else r = m;
    }
    //cout << "binary2: " << cars << ' ' << l << ' ' << r << ' ' << check1(r) << ' ' << check2(t-r) << '\n';
    return (check2(t-r) >= cars);
}

ll binary_output(ll cars) {
    ll l = 0, r = t, m;
    while (l < r - 1) {
        m = (l+r)/2;
        if (check1(m) < cars) l = m;
        else r = m;
    }
    return r;
}

ll binary() {
    ll l = 0, r = t+1, m;
    while (l < r - 1) {
        m = (l+r)/2;
        if (binary2(m)) l = m;
        else r = m;
    }
    return l;
}

ll binary_res;

int main () {
    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> t;
    cin >> n;
    for (ll i = 1 ; i <= n ; ++i)
        cin >> a[i].ready >> a[i].prod;
    cin >> m;
    for (ll i = 1 ; i <= m ; ++i)
        cin >> b[i].ready >> b[i].prod;
    binary_res = binary();
    //cerr << "binary_res: " << binary_res << '\n';
    cout << binary_output(binary_res) << '\n';
    return 0;
}

