#include<iostream>
#include<cmath>
using namespace std;

const int maxn = 128;
int t, n, m, a[maxn], b[maxn], c[maxn], d[maxn];

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> t ;
    cin >> n ;
    int i;
    for(i=1; i<=n; ++i)
    {
        cin >> a[i] >> b[i] ;
    }
    cin >> m ;
    for(i=1; i<=m; ++i)
    {
        cin >> c[i] >> d[i] ;
    }
}

int check(int m1)
{
    int i, cnt1 = 0, cnt2 = 0, m2 = t-m1;
    for(i=1; i<=n; ++i)
    {
        cnt1 += ((m1-a[i])/b[i]);
    }
    for(i=1; i<=m; ++i)
    {
        cnt2 += ((m2-c[i])/d[i]);
    }
    if(cnt1 == cnt2) return 0;
    if(cnt1 < cnt2) return -1;
    return 1;
}

int bin_search()
{
    int l = 1, r = t;
    int mid = (l+r)/2;
    int k = check(mid);
    while(k != 0)
    {
        if(k == -1) l = mid+1;
        else r = mid-1;
        mid = (l+r)/2;
        k = check(mid);
    }
    return mid;
}

void solve()
{
    int ans = bin_search();
    cout << ans << '\n' ;
}

int main()
{
    read();
    solve();
    return 0;
}
